import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { provideRouter } from '@angular/router';

import { routes } from './app.routes';
import { provideHttpClient } from '@angular/common/http';
import { TodoService } from '@core/ports/todo.service';
import { InMemoryTodoService } from '@core/adapters/in-memory-todo.service';
import { TodoBuilder } from '@core/models/builder/todo.builder';

export const appConfig: ApplicationConfig = {
  providers: [
    provideZoneChangeDetection({ eventCoalescing: true }),
    provideRouter(routes),
    provideHttpClient(),
    {
      provide: TodoService,
      useFactory: () =>
        new InMemoryTodoService().withTodos([
          new TodoBuilder().withId(1).withName('Apprendre Angular 19').uncomplete().build(),
          new TodoBuilder().withId(2).withName('Apprendre Java Spring Boot').complete().build(),
          new TodoBuilder().withId(3).withName('Apprendre PostgreSQL').uncomplete().build(),
        ]),
    },
  ],
};
