import { Component, input, output } from '@angular/core';
import { Todo } from '@core/models/todo';
import { FaIconComponent } from '@fortawesome/angular-fontawesome';
import { NgClass } from '@angular/common';

@Component({
  selector: 'app-todo-list-item',
  template: `
    <li class="py-2 w-full">
      <label class="fieldset-label">
        <input type="checkbox" [checked]="todo().completed" class="checkbox" (change)="toggleCompleted.emit(todo())" />
        <span [ngClass]="{ 'line-through': todo().completed }">{{ todo().name }}</span>
        <button class="btn btn-ghost btn-error" (click)="remove.emit(todo())">
          <fa-icon [icon]="['fas', 'trash']"></fa-icon>
        </button>
      </label>
    </li>
  `,
  imports: [FaIconComponent, NgClass],
})
export class TodoListItemComponent {
  todo = input.required<Todo>();
  toggleCompleted = output<Todo>();
  remove = output<Todo>();
}
